 /* -*- Mode: c; indent-tabs-mode: nil; c-basic-offset: 8 -*-
 * vim:expandtab:shiftwidth=8:tabstop=8:
 *
 * Copyright (C) 2002 Cluster File Systems, Inc.
 *   Author: Robert Read <rread@datarithm.net>
 *
 *   This file is part of InterMezzo, http://www.inter-mezzo.org.
 *
 *   InterMezzo is free software; you can redistribute it and/or
 *   modify it under the terms of version 2 of the GNU General Public
 *   License as published by the Free Software Foundation.
 *
 *   InterMezzo is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with InterMezzo; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <glib.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <izolib.h>

/*
 * Open fset fd from the docroot and fsetname. Intended to 
 * be used by cgi progs.
 */
int fset_cgi_open(const char * docroot, const char *fsetname) 
{
        char *filename;
        int fd;

        filename = g_strdup_printf("%s/cache/.intermezzo/%s/ROOT", docroot,
                                      fsetname);
        fd = open(filename, O_RDONLY);
        if (fd < 0) {
                fprintf(stderr, "open(%s, O_RDONLY) failed: %s\n", filename,
                        g_strerror(errno));
        }
        g_free(filename);
        return fd;
}

/*
 * Open cache fd from the docroot. Intended to 
 * be used by cgi progs.
 */
int cache_cgi_open(const char * docroot) 
{
        char *filename;
        int fd;

        filename = g_strdup_printf("%s/cache", docroot);
        fd = open(filename, O_RDONLY);
        if (fd < 0) {
                fprintf(stderr, "open(%s, O_RDONLY) failed: %s\n", filename,
                        g_strerror(errno));
        }
        g_free(filename);
        return fd;
}

