/* -*- Mode: c; indent-tabs-mode: nil; c-basic-offset: 8 -*-
 * vim:expandtab:shiftwidth=8:tabstop=8:
 *
 * Copyright (C) 2001 Cluster File Systems, Inc. <braam@clusterfs.com>
 *
 *   This file is part of InterMezzo, http://www.inter-mezzo.org.
 *
 *   InterMezzo is free software; you can redistribute it and/or
 *   modify it under the terms of version 2 of the GNU General Public
 *   License as published by the Free Software Foundation.
 *
 *   InterMezzo is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with InterMezzo; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * KML Kernel Reintegration
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#define kmalloc(a,b) malloc(a)

#include <linux/intermezzo_fs.h>

/* 'uuid' is the replicator's uuid; the kernel will take care of updating the
 * last_rcvd file based on this value. */
int kml_iocreint(__u32 size, char *ptr, __u32 offset, int dird,
                 uuid_t uuid, __u32 generate_kml)
{
	struct izo_ioctl_data data;
	int err;

	izo_ioctl_init(&data);

        memcpy(data.ioc_uuid, uuid, sizeof(data.ioc_uuid));
	data.ioc_plen1 = size;
	data.ioc_pbuf1 = ptr;
        data.ioc_flags = generate_kml;
        data.ioc_offset = offset;

	err = ioctl(dird, IZO_IOC_REINTKML, &data);
	if (err == -1)
		err = errno;

	return err;
}
